
import mingc

class SWFBase:
    def __init__(self, o):
        self.this = o

class SWFRect(SWFBase):
    def __init__(self, o):
        apply(SWFBase.__init__, (self, this))

    def __init__(self, minX, maxX, minY, maxY):
        self.this = mingc.newSWFRect(minX, maxX, minY, maxY)


class SWFShape(SWFBase):
    def __init__(self, o):
        apply(SWFBase.__init__, (self, this))

    def __init__(self):
        self.this = mingc.newSWFShape()

    def setLine(self, width, r, g, b, a):
        return mingc.SWFShape_setLine(self.this, width, r, g, b, a)

    def addSolidFill(self, r, g, b, a):
        return mingc.SWFShape_addSolidFill(self.this, r, g, b, a)

    def addGradientFill(self, gradient, flags):
        return mingc.SWFShape_addGradientFill(self.this, gradient.this, flags)

    def addBitmapFill(self, bitmap, flags):
        return mingc.SWFShape_addBitmapFill(self.this, bitmap.this, flags)

    def setLeftFill(self, fill):
        mingc.SWFShape_setLeftFill(self.this, fill)

    def setRightFill(self, fill):
        mingc.SWFShape_setRightFill(self.this, fill)

    def moveTo(self, x, y):
        mingc.SWFShape_moveTo(self.this, x, y)

    def lineTo(self, x, y):
        mingc.SWFShape_lineTo(self.this, x, y)

    def lineToRelative(self, dx, dy):
        mingc.SWFShape_lineToRelative(self.this, dx, dy)

    def drawRect(self, rect):
        mingc.SWFShape_drawRect(self.this, rect.this);

    def curveTo(self, controlx, controly, anchorx, anchory):
        mingc.SWFShape_curveTo(self.this, controlx, controly, anchorx, anchory)

    def curveToRelative(self, controldx, controldy, anchordx, anchordy):
        mingc.SWFShape_curveToRelative(self.this, controldx, controldy,
                                       anchordx, anchordy)
    def end(self):
        mingc.SWFShape_end(self.this)

class SWFFill(SWFBase):
    def __init__(self, o):
        apply(SWFBase.__init__, (self, this))

    def __init__(self, o):
        self.this = o

    def rotateTo(self, degrees):
        mingc.SWFFill_rotateTo(self.this, degrees)

    def moveTo(self, x, y):
        mingc.SWFFill_moveTo(self.this, x, y)

    def scaleTo(self, xScale, yScale):
        mingc.SWFFill_scaleTo(self.this, xScale, yScale)

    def skewXTo(self, x):
        mingc.SWFFill_skewXTo(self.this, x);

    def skewYTo(self, y):
        mingc.SWFFill_skewYTo(self.this, y)

class SWFDisplayItem(SWFBase):
    def __init__(self, o):
        apply(SWFBase.__init__, (self, this))

    def __init__(self, o):
        self.this = o

    def rotate(self, degrees):
        mingc.SWFDisplayItem_rotate(self.this, degrees)

    def rotateTo(self, degrees):
        mingc.SWFDisplayItem_rotateTo(self.this, degrees)

    def move(self, x, y):
        mingc.SWFDisplayItem_move(self.this, x, y)

    def moveTo(self, x, y):
        mingc.SWFDisplayItem_moveTo(self.this, x, y)

    def scale(self, xScale, yScale):
        mingc.SWFDisplayItem_scale(self.this, xScale, yScale)

    def scaleTo(self, xScale, yScale):
        mingc.SWFDisplayItem_scaleTo(self.this, xScale, yScale)

    def skewX(self, x):
        mingc.SWFDisplayItem_skewX(self.this, x)

    def skewXTo(self, x):
        mingc.SWFDisplayItem_skewXTo(self.this, x);

    def skewY(self, y):
        mingc.SWFDisplayItem_skewY(self.this, y)

    def skewYTo(self, y):
        mingc.SWFDisplayItem_skewYTo(self.this, y)

    def setName(self, name):
        mingc.SWFDisplayItem_setName(self.this, name)

    def setRatio(self, ratio):
        mingc.SWFDisplayItem_setRatio(self.this, ratio)

    def setDepth(self, depth):
        mingc.SWFDisplayItem_setDepth(self.this, depth)

    def addColor(self, r, g, b, a):
        mingc.SWFDisplayItem_setColorAdd(self.this, r, g, b, a)

    def multColor(self, r, g, b, a):
        mingc.SWFDisplayItem_setColorMult(self.this, r, g, b, a)

    def remove(self):
        mingc.SWFDisplayItem_remove(self.this)

class SWFMovie(SWFBase):
    def __init__(self, o):
        apply(SWFBase.__init__, (self, this))

    def __init__(self):
        self.this = mingc.newSWFMovie()

    def setRate(self, rate):
        mingc.SWFMovie_setRate(self.this, rate)

    def setDimension(self, x, y):
        mingc.SWFMovie_setDimension(self.this, x, y)

    def setBackground(self, r, g, b):
        mingc.SWFMovie_setBackground(self.this, r, g, b)

    def setNumberOfFrames(self, totalFrames):
        mingc.SWFMovie_setNumberOfFrames(self.this, totalFrames)

    def nextFrame(self):
        mingc.SWFMovie_nextFrame(self.this)

    def add(self, block):
        return SWFDisplayItem(mingc.SWFMovie_add(self.this, block.this))

    def remove(self, item):
        mingc.SWFMovie_remove(self.this, item.this)

    def setSoundStream(self, sound):
        mingc.SWFMovie_setSoundStream(self.this, sound.this);

    def simpleOutput(self):
        return mingc.SWFMovie_simpleOutput(self.this)

    def save(self, filename):
        mingc.SWFMovie_save(self.this, filename)

class SWFMovieClip(SWFBase):
    def __init__(self, o):
        apply(SWFbase.__init__, (self, this))

    def __init__(self):
        self.this = mingc.newSWFMovieClip()

    def setNumberOfFrames(self, frames):
        mingc.SWFMovieClip_setNumberOfFrames(self.this, frames)

    def add(self, block):
        return SWFDisplayItem(mingc.SWFMovieClip_add(self.this, block.this))

    def remove(self, item):
        mingc.SWFMovieClip_remove(self.this, item.this)

    def nextFrame(self):
        mingc.SWFMovieClip_nextFrame(self.this)

    def getSprite(self):
        return SWFMovieClip_getSprite(self.this)

class SWFMorphShape(SWFBase):
    def __init__(self, o):
        apply(SWFBase.__init__, (self, this))

    def __init__(self):
        self.this = mingc.newSWFMorphShape()

    def getShape1(self):
        return SWFShape(mingc.getShape1(self.this))

    def getShape2(self):
        return SWFShape(mingc.getShape2(self.this))

class SWFFont(SWFBase):
    def __init__(self, o):
        apply(SWFBase.__init__, (self, this))

    def getAscent(self):
	return SWFFont_getAscent(self.this)

    def getDescent(self):
	return SWFFont_getDescent(self.this)

    def getLeading(self):
	return SWFFont_getLeading(self.this)

    def getWidth(self, string):
	return SWFFont_getWidth(self.this, string)

class SWFText(SWFBase):
    def __init__(self, o):
        apply(SWFBase.__init__, (self, this))

    def __init__(self):
        self.this = mingc.newSWFText()

    def setFont(self, font):
        mingc.SWFText_setFont(self.this, font.this)

    def setHeight(self, height):
        mingc.SWFText_setHeight(self.this, height)

    def setXY(self, x, y):
        mingc.SWFText_setXY(self.this, x, y)

    def setColor(self, r, g, b, a):
        mingc.SWFText_setColor(self.this, r, g, b, a)

    def addString(self, s, advance):
        mingc.SWFText_addString(self.this, s, advance)

    def setSpacing(self, spacing):
        SWFText_setSpacing(self.this, spacing)


class SWFSprite(SWFBase):
    def __init__(self, o):
        apply(SWFBase.__init__, (self, this))

    def __init__(self):
        self.this = mingc.newSWFSprite()

    def addBlock(self, block):
        mingc.SWFSprite_addBlock(self.this, block.this);

class SWFAction(SWFBase):
    def __init__(self, o):
        apply(SWFBase.__init__, (self, this))

    def __init__(self):
        self.this = mingc.newSWFAction()

class SWFGradient(SWFBase):
    def __init__(self, o):
        apply(SWFGradient.__init__, (self, this))

    def __init__(self):
        self.this = mingc.newSWFGradient()

    def addEntry(self, ratio, r, g, b, a):
	mingc.SWFGradient_addEntry(self.this, ratio, r, g, b, a)
